Subject: Allow configuration of template path fallbacks

Description

It would be great if you can configure alternative paths for templates. It would be quite handy when you have to extend existing
package templates.

Right now it is only possible to set one templateRootPath for package. So even if you want to change only one template file, you have
to copy all templates to new location.

This is a placeholder ticket reflecting ticked placed in Extbase.

Related issues:
related to TYPOS.Fluid - Feature # 33487: Configure from what package to use ... Closed 2012-01-27
related to TYPOS.Flow - Feature # 42176: Improve resolving of view Resolved 2012-10-19

Associated revisions

Revision a1173897 - 2013-08-01 12:10 - Bastian Waidelich

[FEATURE] Fallback paths

With this change it will be possible to define multiple values
for the ““template™, ““partial”™ and ““layout™ root path configuration.

Each of the respective options will now have a corresponding setter
that enables configuration of multiple paths to look up when loading a
Fluid template file::

$view->setTemplateRootPaths(array('first/path’, 'second/path’, ...));

The old setters will be kept and they overrule the fallback paths. So::
$view->setTemplateRootPath('some/path’);

would disable the fallback paths of the previous example. The same is true
for ““setPartialRootPath()"" and ““setLayoutRootPath()™.

The rootPath-getters have been deprecated in favor of
““getTemplateRootPaths()™", “"getPartialRootPaths()"" and

““getLayoutRootPaths() ™.
Change-Id: 1530e9a1fadbbd210c980c62cf2022c38fa81bb56

Resolves: #39870
Releases: master

History

#1 - 2012-08-17 07:07 - Sebastian Kurfuerst
- Priority changed from Should have to Could have

We've internally discussed this topic already quite often, and came to the conclusion that template path inheritance would make the whole system a lot
more complex; and especially it is a form of unplanned extension that is very "ad-hoc" -- f.e. by overriding just a single partial it gets very difficult to be
able to update the original package when new variables etc are introduced.

While | understand that it might serve a use-case for Extbase, | wouldn't like to add it into FLOWS3. There, we have TypoScript as extensibility
mechanism which also allows configuring template paths etc.

#2 - 2012-08-17 14:08 - Tymoteusz Motylewski

Sebastian, thank you for your comment! Please see Extbase ticket for general response. | have some questions about FLOWS side of this change.

Just to clarify - | would like to have the same logic for templates, partials and layouts. | started with templates, but when we agree on how should it be

done, then | will implement it for partials and layouts too.

f.e. by overriding just a single partial it gets very difficult

to be able to update the original package when new variables etc are introduced.

Sorry, but I'm not getting the issue here. If new variable was introduced in original package then it makes update your templates much easier, as you

only have to change one partial - the one you're overriding.

There, we have TypoScript as extensibility mechanism which also allows configuring template paths etc.

Please elaborate on this a little bit, it seems very interesting. Do you already have a possibility to configure skins/fallback paths for templates in FLOW3

Typoscript? How does it work?

| would like to keep both Fluids in synch, so your input is very important for me :)

#3 - 2012-08-18 15:30 - Tymoteusz Motylewski

| was also thinking about other implementation approach which will not require any change in fluid (only in extbase).

| mean, to set templateRootPath to view in ActionController, then call $view->canRender() (which will check if template exist) if it returns false, than try

with fallback path.

This would be quite nice solution for templates, but unfortunatelly we can not use it for partials and layouts - as we can not determine what layouts and

partials will be used during rendering, so the view has to know fallback paths himself.

#4 - 2013-06-23 15:32 - Christian Kuhn

It seems, TYPO3 CMS will go ahead here and implements an 'overlay' system with #39868.

This issue is a general demand in extbase/fluid. Simple example is ext:powermail that comes with tons of templates. Mostly, an integrator only wants to
adapt just one or a little number of them. To do that, currently all templates have to be copied around and need to be compared if the extension is

updated. This is pretty uncool.

| do understand that this feature adds complexity to the system, but it is really useful if used with care.

2015-08-03 2/4



#5 - 2013-07-09 16:48 - Bastian Waidelich

Christian Kuhn wrote:

I do understand that this feature adds complexity to the system, but it is really useful if used with care.

Christian you're right and we have been convinced in the meantime ;)

We're about to discuss the next steps here, because for Flow we'll soon have a way to solve the issue — but slightly differently (see
https://review.typo3.org/#/c/16392/). I'll add you to the doodle for a discussion

#6 - 2013-07-29 13:59 - Bastian Waidelich
- Category set to View
- Status changed from New to Accepted

- Assigned To set to Bastian Waidelich
#7 - 2013-07-29 14:30 - Gerrit Code Review

- Status changed from Accepted to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at https://review.typo3.0rg/22658

#8 - 2013-07-29 14:38 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.0rg/22658

#9 - 2013-07-29 15:27 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.

It is available at https://review.typo3.org/22658

#10 - 2013-07-29 15:29 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at https://review.typo3.0rg/22658

#11 - 2013-07-30 10:28 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.
It is available at https://review.typo3.0rg/22658

#12 - 2013-08-01 12:11 - Gerrit Code Review

Patch set 6 for branch master has been pushed to the review server.
#13 - 2013-08-07 15:35 - Bastian Waidelich
- Status changed from Under Review to Resolved

- % Done changed from 0 to 100

Applied in changeset commit:a1173897ceb00aa20669f8dd14b8cc4f795cb620.
